org.springframework.web.portlet.context

## Class PortletContextScope

- java.lang.Object
- - org.springframework.web.portlet.context.PortletContextScope

- All Implemented Interfaces:
    Scope, DisposableBean

      public class PortletContextScope
      extends Object
      implements Scope, DisposableBean

  `Scope` wrapper for a PortletContext, i.e. for global web application attributes.

  This differs from traditional Spring singletons in that it exposes attributes in the PortletContext. Those attributes will get destroyed whenever the entire application shuts down, which might be earlier or later than the shutdown of the containing Spring ApplicationContext.

  The associated destruction mechanism relies on a `ContextCleanupListener` being registered in `web.xml`. Note that `ContextLoaderListener` includes ContextCleanupListener's functionality.

  This scope is registered as default scope with key `"application"`.

  Since:
    3.0
  Author:
    Juergen Hoeller
  See Also:
    `ContextCleanupListener`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PortletContextScope(PortletContext portletContext)` Create a new Scope wrapper for the given PortletContext.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `destroy()` Invoke all registered destruction callbacks.
    `Object` | `get(String name, ObjectFactory<?> objectFactory)` Return the object with the given name from the underlying scope, `creating it` if not found in the underlying storage mechanism.
    `String` | `getConversationId()` Return the conversation ID for the current underlying scope, if any.
    `void` | `registerDestructionCallback(String name, Runnable callback)` Register a callback to be executed on destruction of the specified object in the scope (or at destruction of the entire scope, if the scope does not destroy individual objects but rather only terminates in its entirety).
    `Object` | `remove(String name)` Remove the object with the given `name` from the underlying scope.
    `Object` | `resolveContextualObject(String key)` Resolve the contextual object for the given key, if any.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PortletContextScope

          public PortletContextScope(PortletContext portletContext)

      Create a new Scope wrapper for the given PortletContext.
      Parameters:
        `portletContext` - the PortletContext to wrap

  - ### Method Detail

    - #### get

          public Object get(String name,
                   ObjectFactory<?> objectFactory)

      Description copied from interface: `Scope`
      Return the object with the given name from the underlying scope, `creating it` if not found in the underlying storage mechanism.

      This is the central operation of a Scope, and the only operation that is absolutely required.

      Specified by:
        `get` in interface `Scope`
      Parameters:
        `name` - the name of the object to retrieve
        `objectFactory` - the `ObjectFactory` to use to create the scoped object if it is not present in the underlying storage mechanism
      Returns:
        the desired object (never `null`)

    - #### remove

          public Object remove(String name)

      Description copied from interface: `Scope`
      Remove the object with the given `name` from the underlying scope.

      Returns `null` if no object was found; otherwise returns the removed `Object`.

      Note that an implementation should also remove a registered destruction callback for the specified object, if any. It does, however, not need to execute a registered destruction callback in this case, since the object will be destroyed by the caller (if appropriate).

      Note: This is an optional operation. Implementations may throw `UnsupportedOperationException` if they do not support explicitly removing an object.

      Specified by:
        `remove` in interface `Scope`
      Parameters:
        `name` - the name of the object to remove
      Returns:
        the removed object, or `null` if no object was present
      See Also:
        `Scope.registerDestructionCallback(java.lang.String, java.lang.Runnable)`

    - #### registerDestructionCallback

          public void registerDestructionCallback(String name,
                                         Runnable callback)

      Description copied from interface: `Scope`
      Register a callback to be executed on destruction of the specified object in the scope (or at destruction of the entire scope, if the scope does not destroy individual objects but rather only terminates in its entirety).

      Note: This is an optional operation. This method will only be called for scoped beans with actual destruction configuration (DisposableBean, destroy-method, DestructionAwareBeanPostProcessor). Implementations should do their best to execute a given callback at the appropriate time. If such a callback is not supported by the underlying runtime environment at all, the callback must be ignored and a corresponding warning should be logged.

      Note that 'destruction' refers to to automatic destruction of the object as part of the scope's own lifecycle, not to the individual scoped object having been explicitly removed by the application. If a scoped object gets removed via this facade's `Scope.remove(String)` method, any registered destruction callback should be removed as well, assuming that the removed object will be reused or manually destroyed.

      Specified by:
        `registerDestructionCallback` in interface `Scope`
      Parameters:
        `name` - the name of the object to execute the destruction callback for
        `callback` - the destruction callback to be executed. Note that the passed-in Runnable will never throw an exception, so it can safely be executed without an enclosing try-catch block. Furthermore, the Runnable will usually be serializable, provided that its target object is serializable as well.
      See Also:
        `DisposableBean`, `AbstractBeanDefinition.getDestroyMethodName()`, `DestructionAwareBeanPostProcessor`

    - #### resolveContextualObject

          public Object resolveContextualObject(String key)

      Description copied from interface: `Scope`
      Resolve the contextual object for the given key, if any. E.g. the HttpServletRequest object for key "request".
      Specified by:
        `resolveContextualObject` in interface `Scope`
      Parameters:
        `key` - the contextual key
      Returns:
        the corresponding object, or `null` if none found

    - #### getConversationId

          public String getConversationId()

      Description copied from interface: `Scope`
      Return the conversation ID for the current underlying scope, if any.

      The exact meaning of the conversation ID depends on the underlying storage mechanism. In the case of session-scoped objects, the conversation ID would typically be equal to (or derived from) the `session ID`; in the case of a custom conversation that sits within the overall session, the specific ID for the current conversation would be appropriate.

      Note: This is an optional operation. It is perfectly valid to return `null` in an implementation of this method if the underlying storage mechanism has no obvious candidate for such an ID.

      Specified by:
        `getConversationId` in interface `Scope`
      Returns:
        the conversation ID, or `null` if there is no conversation ID for the current scope

    - #### destroy

          public void destroy()

      Invoke all registered destruction callbacks. To be called on ServletContext shutdown.
      Specified by:
        `destroy` in interface `DisposableBean`
      See Also:
        `ContextCleanupListener`